# -*- coding: cp949 -*-
import os

def get_unmatched(rootdir, movext, subext, recursive):
    '''
    Ʈ 丮 Ī ʴ /ڸ  Ʈ ˻.
      ÷̾     ڵ ڸ
    ҷ ؼ  Ȯڸ ٸ   ̸
     ڸ  ־ Ѵ.

    ̷  ڸ  ùٸ   ̷ 'Īȴ'
     ǥϰ,  ڸ    ̷ ϰ
      ʸ   Ī ʴ´ٰ ǥѴ.

    Args
        rootdir: Ʈ 丮.   ڸ  ˻Ǵ
                 ֻ 

        movext:   Ȯ Ʈ. տ ٴ  .
                '(set)' Է 

        subext: ڸ  Ȯ Ʈ. movext  .

        recursive: True/False. rootdir  ˻
                   ϴ ġ

    Returns
        2 Ʈ ϵȴ.
        ϳ Ī ʴ   Ʈ̰ ٸ ϳ
        Ī ʴ ڸ  Ʈ̴.  Ʈ 
        δ  η Էµȴ.

    '''

    unmatmov = []
    unmatsub = []

    if recursive:
        for dirpath, dirnames, files in os.walk(rootdir):
            mov, sub = unmatch_onedir(dirpath, movext, subext)
            unmatmov += mov
            unmatsub += sub
    else:
        unmatmov, unmatsub = unmatch_onedir(rootdir, movext, subext)

    return unmatmov, unmatsub




def unmatch_onedir(rootdir, movext, subext):

    unmatmov = []
    unmatsub = []

    for f in os.listdir(rootdir):

        path = rootdir + os.path.sep + f
        if os.path.isdir(path):
            continue

        spl = os.path.splitext(f)
        ext = spl[1].lower()
        fnd = False

        if ext:
            # movie file found, subtitle check.
            if ext[1:] in movext:
                for p in subext:
                    pair = spl[0] + '.' + p
                    abp  = rootdir + os.path.sep + pair

                    if os.path.exists(abp):
                        fnd = True
                        break

                if fnd == False:
                    unmatmov.append(path)

            # subtitle file found, movie file check.
            elif ext[1:] in subext:
                for p in movext:
                    pair = spl[0] + '.' + p
                    abp  = rootdir + os.path.sep + pair

                    if os.path.exists(abp):
                        fnd = True
                        break

                if fnd == False:
                    unmatsub.append(path)

    return unmatmov, unmatsub
